LogTo("/home/agustin/gap-4.10.1/bin/ufo/cleft-br2a-M12-N4.log");

LoadPackage("GBNP");

#cleft objects for the case N=4, M=12

#case 1: we deform y1^3

GBNP.ConfigPrint("y2","y12","y112","y1","x2","x12","x112","x1");

q:=E(4);;
z:=E(3);;
qz:=z*q^-1;;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;


#we need q21^3=1, so we just so q21=1,z,z^2

#q21=1


q11:=z;;
q21:=1;;
q12:=(q21*q)^-1;;
q22:=q;;

F:=Field(t1,t2);;
F1:=One(F);;

y2:=[[[1]],[F1]];;
y12:=[[[2]],[F1]];;
y112:=[[[3]],[F1]];;
y1:=[[[4]],[F1]];;

x2:=[[[5]],[F1]];;
x12:=[[[6]],[F1]];;
x112:=[[[7]],[F1]];;
x1:=[[[8]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
r1d:=AddNP(r1,[[[]],[F1]],F1,-t1);;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
r2d:=AddNP(r2,[[[]],[F1]],F1,-t2);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

#r3:=MulNP(y12,MulNP(y12,y12));;
#s3:=MulNP(x12,MulNP(x12,x12));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;

c11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-q11);;
c12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-q12);;
c21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-q21);;
c22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-q22);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


K:=[
r1d,r2,
s1,s2,
y221,x221,
r12,r112,
s12,s112,
c11,c12,c21,c22
];;

G:=SGrobner(K);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112na2:=StrongNormalFormNP(MulNP(d112,d112),G);;
d112na3:=StrongNormalFormNP(MulNP(d112na2,d112),G);;
d112na4:=StrongNormalFormNP(MulNP(d112na3,d112),G);;
d112na5:=StrongNormalFormNP(MulNP(d112na4,d112),G);;
d112na6:=StrongNormalFormNP(MulNP(d112na5,d112),G);;
d112na7:=StrongNormalFormNP(MulNP(d112na6,d112),G);;
d112na8:=StrongNormalFormNP(MulNP(d112na7,d112),G);;
d112na9:=StrongNormalFormNP(MulNP(d112na8,d112),G);;
d112na10:=StrongNormalFormNP(MulNP(d112na9,d112),G);;
d112na11:=StrongNormalFormNP(MulNP(d112na10,d112),G);;
d112na12:=StrongNormalFormNP(MulNP(d112na11,d112),G);;

Print("\n y1^3=t1, q21=1. the coaction is: \n");

PrintNP(d112na12);



#q21=z

F:=Field(t1,t2);;
F1:=One(F);;


q11:=z;;
q21:=z;;
q12:=(q21*q)^-1;;
q22:=q;;

y2:=[[[1]],[F1]];;
y12:=[[[2]],[F1]];;
y112:=[[[3]],[F1]];;
y1:=[[[4]],[F1]];;

x2:=[[[5]],[F1]];;
x12:=[[[6]],[F1]];;
x112:=[[[7]],[F1]];;
x1:=[[[8]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
r1d:=AddNP(r1,[[[]],[F1]],F1,-t1);;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
r2d:=AddNP(r2,[[[]],[F1]],F1,-t2);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

#r3:=MulNP(y12,MulNP(y12,y12));;
#s3:=MulNP(x12,MulNP(x12,x12));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;

c11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-q11);;
c12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-q12);;
c21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-q21);;
c22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-q22);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


K:=[
r1d,r2,
s1,s2,
y221,x221,
r12,r112,
s12,s112,
c11,c12,c21,c22
];;

G:=SGrobner(K);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112na2:=StrongNormalFormNP(MulNP(d112,d112),G);;
d112na3:=StrongNormalFormNP(MulNP(d112na2,d112),G);;
d112na4:=StrongNormalFormNP(MulNP(d112na3,d112),G);;
d112na5:=StrongNormalFormNP(MulNP(d112na4,d112),G);;
d112na6:=StrongNormalFormNP(MulNP(d112na5,d112),G);;
d112na7:=StrongNormalFormNP(MulNP(d112na6,d112),G);;
d112na8:=StrongNormalFormNP(MulNP(d112na7,d112),G);;
d112na9:=StrongNormalFormNP(MulNP(d112na8,d112),G);;
d112na10:=StrongNormalFormNP(MulNP(d112na9,d112),G);;
d112na11:=StrongNormalFormNP(MulNP(d112na10,d112),G);;
d112na12:=StrongNormalFormNP(MulNP(d112na11,d112),G);;

Print("\n y1^3=t1, q21=E(3). the coaction is: \n");

PrintNP(d112na12);






#q21=z^2

F:=Field(t1,t2);;
F1:=One(F);;

q11:=z;;
q21:=z^2;;
q12:=(q21*q)^-1;;
q22:=q;;

y2:=[[[1]],[F1]];;
y12:=[[[2]],[F1]];;
y112:=[[[3]],[F1]];;
y1:=[[[4]],[F1]];;

x2:=[[[5]],[F1]];;
x12:=[[[6]],[F1]];;
x112:=[[[7]],[F1]];;
x1:=[[[8]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
r1d:=AddNP(r1,[[[]],[F1]],F1,-t1);;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
r2d:=AddNP(r2,[[[]],[F1]],F1,-t2);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

#r3:=MulNP(y12,MulNP(y12,y12));;
#s3:=MulNP(x12,MulNP(x12,x12));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;

c11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-q11);;
c12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-q12);;
c21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-q21);;
c22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-q22);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


K:=[
r1d,r2,
s1,s2,
y221,x221,
r12,r112,
s12,s112,
c11,c12,c21,c22
];;

G:=SGrobner(K);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112na2:=StrongNormalFormNP(MulNP(d112,d112),G);;
d112na3:=StrongNormalFormNP(MulNP(d112na2,d112),G);;
d112na4:=StrongNormalFormNP(MulNP(d112na3,d112),G);;
d112na5:=StrongNormalFormNP(MulNP(d112na4,d112),G);;
d112na6:=StrongNormalFormNP(MulNP(d112na5,d112),G);;
d112na7:=StrongNormalFormNP(MulNP(d112na6,d112),G);;
d112na8:=StrongNormalFormNP(MulNP(d112na7,d112),G);;
d112na9:=StrongNormalFormNP(MulNP(d112na8,d112),G);;
d112na10:=StrongNormalFormNP(MulNP(d112na9,d112),G);;
d112na11:=StrongNormalFormNP(MulNP(d112na10,d112),G);;
d112na12:=StrongNormalFormNP(MulNP(d112na11,d112),G);;


Print("\n y1^3=t1, q21=E(3)^2. the coaction is: \n");

PrintNP(d112na12);





########################################################################################################################
#we deform y2^4
#cleft:
########################################################################################################################


LoadPackage("GBNP");
GBNP.ConfigPrint("y2","y12","y112","y1","x2","x12","x112","x1");

q:=E(4);;
z:=E(3);;
qz:=z*q^-1;;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

#we need q12^4=1, so we just take q12=1,q,q^2,q^3

#q12=1


F:=Field(t1,t2);;
F1:=One(F);;

q11:=z;;
q12:=F1;;
q21:=(q12*q)^-1;;
q22:=q;;



y2:=[[[1]],[F1]];;
y12:=[[[2]],[F1]];;
y112:=[[[3]],[F1]];;
y1:=[[[4]],[F1]];;

x2:=[[[5]],[F1]];;
x12:=[[[6]],[F1]];;
x112:=[[[7]],[F1]];;
x1:=[[[8]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
r1d:=AddNP(r1,[[[]],[F1]],F1,-t1);;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
r2d:=AddNP(r2,[[[]],[F1]],F1,-t2);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;


c11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-q11);;
c12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-q12);;
c21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-q21);;
c22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-q22);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;



K:=[
r1,r2d,
s1,s2,
y221,x221,
r12,r112,
s12,s112,
c11,c12,c21,c22
];;

G:=SGrobner(K);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112na2:=StrongNormalFormNP(MulNP(d112,d112),G);;
d112na3:=StrongNormalFormNP(MulNP(d112na2,d112),G);;
d112na4:=StrongNormalFormNP(MulNP(d112na3,d112),G);;
d112na5:=StrongNormalFormNP(MulNP(d112na4,d112),G);;
d112na6:=StrongNormalFormNP(MulNP(d112na5,d112),G);;
d112na7:=StrongNormalFormNP(MulNP(d112na6,d112),G);;
d112na8:=StrongNormalFormNP(MulNP(d112na7,d112),G);;
d112na9:=StrongNormalFormNP(MulNP(d112na8,d112),G);;
d112na10:=StrongNormalFormNP(MulNP(d112na9,d112),G);;
d112na11:=StrongNormalFormNP(MulNP(d112na10,d112),G);;
d112na12:=StrongNormalFormNP(MulNP(d112na11,d112),G);;

Print("\n y2^4=t2, q11=1. the coaction is: \n");

PrintNP(d112na12);





#q21=q

q11:=z;;
q12:=q;;
q21:=(q12*q)^-1;;
q22:=q;;


y2:=[[[1]],[F1]];;
y12:=[[[2]],[F1]];;
y112:=[[[3]],[F1]];;
y1:=[[[4]],[F1]];;

x2:=[[[5]],[F1]];;
x12:=[[[6]],[F1]];;
x112:=[[[7]],[F1]];;
x1:=[[[8]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
r1d:=AddNP(r1,[[[]],[F1]],F1,-t1);;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
r2d:=AddNP(r2,[[[]],[F1]],F1,-t2);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;


c11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-q11);;
c12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-q12);;
c21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-q21);;
c22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-q22);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;



K:=[
r1,r2d,
s1,s2,
y221,x221,
r12,r112,
s12,s112,
c11,c12,c21,c22
];;

G:=SGrobner(K);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112na2:=StrongNormalFormNP(MulNP(d112,d112),G);;
d112na3:=StrongNormalFormNP(MulNP(d112na2,d112),G);;
d112na4:=StrongNormalFormNP(MulNP(d112na3,d112),G);;
d112na5:=StrongNormalFormNP(MulNP(d112na4,d112),G);;
d112na6:=StrongNormalFormNP(MulNP(d112na5,d112),G);;
d112na7:=StrongNormalFormNP(MulNP(d112na6,d112),G);;
d112na8:=StrongNormalFormNP(MulNP(d112na7,d112),G);;
d112na9:=StrongNormalFormNP(MulNP(d112na8,d112),G);;
d112na10:=StrongNormalFormNP(MulNP(d112na9,d112),G);;
d112na11:=StrongNormalFormNP(MulNP(d112na10,d112),G);;
d112na12:=StrongNormalFormNP(MulNP(d112na11,d112),G);;

Print("\n y2^4=t2, q12=E(4). the coaction is: \n");

PrintNP(d112na12);




#q21=q^2

q11:=z;;
q12:=q^2;;
q21:=(q12*q)^-1;;
q22:=q;;


y2:=[[[1]],[F1]];;
y12:=[[[2]],[F1]];;
y112:=[[[3]],[F1]];;
y1:=[[[4]],[F1]];;

x2:=[[[5]],[F1]];;
x12:=[[[6]],[F1]];;
x112:=[[[7]],[F1]];;
x1:=[[[8]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
r1d:=AddNP(r1,[[[]],[F1]],F1,-t1);;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
r2d:=AddNP(r2,[[[]],[F1]],F1,-t2);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;


c11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-q11);;
c12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-q12);;
c21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-q21);;
c22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-q22);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;



K:=[
r1,r2d,
s1,s2,
y221,x221,
r12,r112,
s12,s112,
c11,c12,c21,c22
];;

G:=SGrobner(K);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112na2:=StrongNormalFormNP(MulNP(d112,d112),G);;
d112na3:=StrongNormalFormNP(MulNP(d112na2,d112),G);;
d112na4:=StrongNormalFormNP(MulNP(d112na3,d112),G);;
d112na5:=StrongNormalFormNP(MulNP(d112na4,d112),G);;
d112na6:=StrongNormalFormNP(MulNP(d112na5,d112),G);;
d112na7:=StrongNormalFormNP(MulNP(d112na6,d112),G);;
d112na8:=StrongNormalFormNP(MulNP(d112na7,d112),G);;
d112na9:=StrongNormalFormNP(MulNP(d112na8,d112),G);;
d112na10:=StrongNormalFormNP(MulNP(d112na9,d112),G);;
d112na11:=StrongNormalFormNP(MulNP(d112na10,d112),G);;
d112na12:=StrongNormalFormNP(MulNP(d112na11,d112),G);;

Print("\n y2^4=t2, q12=E(4)^2. the coaction is: \n");

PrintNP(d112na12);




#q21=q^3

q11:=z;;
q12:=q^3;;
q21:=(q12*q)^-1;;
q22:=q;;


y2:=[[[1]],[F1]];;
y12:=[[[2]],[F1]];;
y112:=[[[3]],[F1]];;
y1:=[[[4]],[F1]];;

x2:=[[[5]],[F1]];;
x12:=[[[6]],[F1]];;
x112:=[[[7]],[F1]];;
x1:=[[[8]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
r1d:=AddNP(r1,[[[]],[F1]],F1,-t1);;
s1:=MulNP(x1,MulNP(x1,x1));;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
r2d:=AddNP(r2,[[[]],[F1]],F1,-t2);;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;


c11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-q11);;
c12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-q12);;
c21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-q21);;
c22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-q22);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;



K:=[
r1,r2d,
s1,s2,
y221,x221,
r12,r112,
s12,s112,
c11,c12,c21,c22
];;

G:=SGrobner(K);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112na2:=StrongNormalFormNP(MulNP(d112,d112),G);;
d112na3:=StrongNormalFormNP(MulNP(d112na2,d112),G);;
d112na4:=StrongNormalFormNP(MulNP(d112na3,d112),G);;
d112na5:=StrongNormalFormNP(MulNP(d112na4,d112),G);;
d112na6:=StrongNormalFormNP(MulNP(d112na5,d112),G);;
d112na7:=StrongNormalFormNP(MulNP(d112na6,d112),G);;
d112na8:=StrongNormalFormNP(MulNP(d112na7,d112),G);;
d112na9:=StrongNormalFormNP(MulNP(d112na8,d112),G);;
d112na10:=StrongNormalFormNP(MulNP(d112na9,d112),G);;
d112na11:=StrongNormalFormNP(MulNP(d112na10,d112),G);;
d112na12:=StrongNormalFormNP(MulNP(d112na11,d112),G);;

Print("\n y2^4=t2, q12=E(4)^3. the coaction is: \n");

PrintNP(d112na12);






