LogTo("/home/agustin/gap-4.10.1/bin/ufo/lift-br2a-M12-N4-t1-PBW.log");

LoadPackage("GBNP");

#lifts with PBW

#we deform y1^3

GBNP.ConfigPrint("g2","g1","y2","y12","y112","y1","x2","x12","x112","x1");

q:=E(4);;
z:=E(3);;
qz:=z*q^-1;;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
F:=Field(t1);;
F1:=One(F);;

#we need q21^3=1, so we just so q21=1,z,z^2

##################################################################################################################
#q21=1
##################################################################################################################

q11:=z;;
q21:=1;;
q12:=(q21*q)^-1;;
q22:=q;;



g2:=[[[1]],[F1]];;
g1:=[[[2]],[F1]];;

y2:=[[[3]],[F1]];;
y12:=[[[4]],[F1]];;
y112:=[[[5]],[F1]];;
y1:=[[[6]],[F1]];;

x2:=[[[7]],[F1]];;
x12:=[[[8]],[F1]];;
x112:=[[[9]],[F1]];;
x1:=[[[10]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
gg1:=MulNP(g1,MulNP(g1,g1));;
r1d:=AddNP(AddNP(r1,[[[]],[F1]],F1,-t1),gg1,F1,t1);;

s1:=MulNP(x1,MulNP(x1,x1));;
s1d:=AddNP(s1,[[[]],[F1]],F1,-t1);;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;


gy11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-q11);;
gy12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-q12);;
gy21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-q21);;
gy22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-q22);;
gx11:=AddNP(MulNP(g1,x1),MulNP(x1,g1),F1,-F1);;
gx12:=AddNP(MulNP(g1,x2),MulNP(x2,g1),F1,-F1);;
gx21:=AddNP(MulNP(g2,x1),MulNP(x1,g2),F1,-F1);;
gx22:=AddNP(MulNP(g2,x2),MulNP(x2,g2),F1,-F1);;
xy11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-F1);;
xy12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-F1);;
xy21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-F1);;
xy22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-F1);;
gg12:=AddNP(MulNP(g2,g1),MulNP(g1,g2),F1,-F1);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


K:=[
r1d,r2,
s1d,s2,
y221,x221,
r12,s12,r112,s112,
gy11,gy12,gy21,gy22,
gx11,gx12,gx21,gx22,
xy11,xy12,xy21,xy22,
gg12
];;

G:=SGrobner(K);


d1:=AddNP(y1,MulNP(g1,x1),F1,F1);;
d2:=AddNP(y2,MulNP(g2,x2),F1,F1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112n:=function(n)
if n=1 then
return d112;
else return StrongNormalFormNP(MulNP(d112,d112n(n-1)),G);
fi;
end;;

Print("\n y1^3=t1, q21=1. the coaction is: \n");

PrintNP(d112n(12));

##################################################################################################################
#q21=z
##################################################################################################################


q11:=z;;
q21:=z;;
q12:=(q21*q)^-1;;
q22:=q;;



g2:=[[[1]],[F1]];;
g1:=[[[2]],[F1]];;

y2:=[[[3]],[F1]];;
y12:=[[[4]],[F1]];;
y112:=[[[5]],[F1]];;
y1:=[[[6]],[F1]];;

x2:=[[[7]],[F1]];;
x12:=[[[8]],[F1]];;
x112:=[[[9]],[F1]];;
x1:=[[[10]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
gg1:=MulNP(g1,MulNP(g1,g1));;
r1d:=AddNP(AddNP(r1,[[[]],[F1]],F1,-t1),gg1,F1,t1);;

s1:=MulNP(x1,MulNP(x1,x1));;
s1d:=AddNP(s1,[[[]],[F1]],F1,-t1);;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;


gy11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-q11);;
gy12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-q12);;
gy21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-q21);;
gy22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-q22);;
gx11:=AddNP(MulNP(g1,x1),MulNP(x1,g1),F1,-F1);;
gx12:=AddNP(MulNP(g1,x2),MulNP(x2,g1),F1,-F1);;
gx21:=AddNP(MulNP(g2,x1),MulNP(x1,g2),F1,-F1);;
gx22:=AddNP(MulNP(g2,x2),MulNP(x2,g2),F1,-F1);;
xy11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-F1);;
xy12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-F1);;
xy21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-F1);;
xy22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-F1);;
gg12:=AddNP(MulNP(g2,g1),MulNP(g1,g2),F1,-F1);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


K:=[
r1d,r2,
s1d,s2,
y221,x221,
r12,s12,r112,s112,
gy11,gy12,gy21,gy22,
gx11,gx12,gx21,gx22,
xy11,xy12,xy21,xy22,
gg12
];;

G:=SGrobner(K);


d1:=AddNP(y1,MulNP(g1,x1),F1,F1);;
d2:=AddNP(y2,MulNP(g2,x2),F1,F1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112n:=function(n)
if n=1 then
return d112;
else return StrongNormalFormNP(MulNP(d112,d112n(n-1)),G);
fi;
end;;

Print("\n y1^3=t1, q21=z. the coaction is: \n");

PrintNP(d112n(12));

##################################################################################################################
#q21=z^2
##################################################################################################################


q11:=z;;
q21:=z^2;;
q12:=(q21*q)^-1;;
q22:=q;;


g2:=[[[1]],[F1]];;
g1:=[[[2]],[F1]];;

y2:=[[[3]],[F1]];;
y12:=[[[4]],[F1]];;
y112:=[[[5]],[F1]];;
y1:=[[[6]],[F1]];;

x2:=[[[7]],[F1]];;
x12:=[[[8]],[F1]];;
x112:=[[[9]],[F1]];;
x1:=[[[10]],[F1]];;

r1:=MulNP(y1,MulNP(y1,y1));;
gg1:=MulNP(g1,MulNP(g1,g1));;
r1d:=AddNP(AddNP(r1,[[[]],[F1]],F1,-t1),gg1,F1,t1);;

s1:=MulNP(x1,MulNP(x1,x1));;
s1d:=AddNP(s1,[[[]],[F1]],F1,-t1);;

r2:=MulNP(y2,MulNP(y2,MulNP(y2,y2)));;
s2:=MulNP(x2,MulNP(x2,MulNP(x2,x2)));;

r12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12),F1,-F1);;
s12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12),F1,-F1);;

r112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12),F1,-F1);;
s112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12),F1,-F1);;


gy11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-q11);;
gy12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-q12);;
gy21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-q21);;
gy22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-q22);;
gx11:=AddNP(MulNP(g1,x1),MulNP(x1,g1),F1,-F1);;
gx12:=AddNP(MulNP(g1,x2),MulNP(x2,g1),F1,-F1);;
gx21:=AddNP(MulNP(g2,x1),MulNP(x1,g2),F1,-F1);;
gx22:=AddNP(MulNP(g2,x2),MulNP(x2,g2),F1,-F1);;
xy11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),F1,-F1);;
xy12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),F1,-F1);;
xy21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),F1,-F1);;
xy22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),F1,-F1);;
gg12:=AddNP(MulNP(g2,g1),MulNP(g1,g2),F1,-F1);;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;


K:=[
r1d,r2,
s1d,s2,
y221,x221,
r12,s12,r112,s112,
gy11,gy12,gy21,gy22,
gx11,gx12,gx21,gx22,
xy11,xy12,xy21,xy22,
gg12
];;

G:=SGrobner(K);


d1:=AddNP(y1,MulNP(g1,x1),F1,F1);;
d2:=AddNP(y2,MulNP(g2,x2),F1,F1);;

d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12),G);

d112n:=function(n)
if n=1 then
return d112;
else return StrongNormalFormNP(MulNP(d112,d112n(n-1)),G);
fi;
end;;

Print("\n y1^3=t1, q21=z^2. the coaction is: \n");

PrintNP(d112n(12));
