LogTo("/home/agustin/gap-4.10.1/bin/ufo/lift-br2a-M4-N12-E(12)-PBW.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("g_{2}","g_{1}","a_{2}","a_{1}","y_{2}","y_{1}");

g2:=[[[1]],[1]];
g1:=[[[2]],[1]];
a2:=[[[3]],[1]];
a1:=[[[4]],[1]];
y2:=[[[5]],[1]];
y1:=[[[6]],[1]];

#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=1\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^0*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*E(3)^2*q21*t1^2;;

dnb4a:=StrongNormalFormNP(AddNP(dnb4,MulNP(d2,MulNP(d2,MulNP(d12,d12))),1,h),G1);;
ynb4a:=StrongNormalFormNP(AddNP(ynb4,MulNP(y2,MulNP(y2,MulNP(y12,y12))),1,h),G1);;

ynb4g:=MulNP(ynb4a,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4a,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#In order to write the difference r112 more friendly, we define a new term called l

l1:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,MulNP(a1,a2))))),G1);;
l2:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a1,a2))))),G1);;
l3:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,a1))))),G1);;
l4:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,a1))))),G1);;

l:=AddNP(l1,AddNP(l2,AddNP(l3,l4,(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2*q21^2,(-4*E(12)^4-8*E(12)^7+4*E(12)^8-8*E(12)^11)*t1^2*q21),(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2,1),(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21,1);;

#We calculate the difference
Print("\n The difference between r112 and l is \n");
PrintNP(AddNP(r112,l,1,-1));

# The difference is zero. Then, we can rewrite the difference r112 using the term l

#Finally we write the term l on the PBW basis.

j:=(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21;;
f:=MulNP(a12,a12);;                                                                                                                                                      
ff:=MulNP(a2,MulNP(a2,f));;

PrintNP(StrongNormalFormNP(AddNP(l,ff,1,-j),G1));



#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^1*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*E(3)^2*q21*t1^2;;

dnb4a:=StrongNormalFormNP(AddNP(dnb4,MulNP(d2,MulNP(d2,MulNP(d12,d12))),1,h),G1);;
ynb4a:=StrongNormalFormNP(AddNP(ynb4,MulNP(y2,MulNP(y2,MulNP(y12,y12))),1,h),G1);;

ynb4g:=MulNP(ynb4a,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4a,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#In order to write the difference r112 more friendly, we define a new term called l

l1:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,MulNP(a1,a2))))),G1);;
l2:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a1,a2))))),G1);;
l3:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,a1))))),G1);;
l4:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,a1))))),G1);;

l:=AddNP(l1,AddNP(l2,AddNP(l3,l4,(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2*q21^2,(-4*E(12)^4-8*E(12)^7+4*E(12)^8-8*E(12)^11)*t1^2*q21),(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2,1),(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21,1);;

#We calculate the difference
Print("\n The difference between r112 and l is \n");
PrintNP(AddNP(r112,l,1,-1));

# The difference is zero. Then, we can rewrite the difference r112 using the term l

#Finally we write the term l on the PBW basis.

j:=(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21;;
f:=MulNP(a12,a12);;                                                                                                                                                      
ff:=MulNP(a2,MulNP(a2,f));;

PrintNP(StrongNormalFormNP(AddNP(l,ff,1,-j),G1));



#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)^2\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^2*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*E(3)^2*q21*t1^2;;

dnb4a:=StrongNormalFormNP(AddNP(dnb4,MulNP(d2,MulNP(d2,MulNP(d12,d12))),1,h),G1);;
ynb4a:=StrongNormalFormNP(AddNP(ynb4,MulNP(y2,MulNP(y2,MulNP(y12,y12))),1,h),G1);;

ynb4g:=MulNP(ynb4a,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4a,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#In order to write the difference r112 more friendly, we define a new term called l

l1:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,MulNP(a1,a2))))),G1);;
l2:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a1,a2))))),G1);;
l3:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,a1))))),G1);;
l4:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,a1))))),G1);;

l:=AddNP(l1,AddNP(l2,AddNP(l3,l4,(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2*q21^2,(-4*E(12)^4-8*E(12)^7+4*E(12)^8-8*E(12)^11)*t1^2*q21),(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2,1),(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21,1);;

#We calculate the difference
Print("\n The difference between r112 and l is \n");
PrintNP(AddNP(r112,l,1,-1));

# The difference is zero. Then, we can rewrite the difference r112 using the term l

#Finally we write the term l on the PBW basis.

j:=(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21;;
f:=MulNP(a12,a12);;                                                                                                                                                      
ff:=MulNP(a2,MulNP(a2,f));;

PrintNP(StrongNormalFormNP(AddNP(l,ff,1,-j),G1));



#########################################################
Print("\n \n Case lambda1 nonzero, lambda2 zero, q21=1\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^0*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y212,a212,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*E(3)^2*q21*t1^2;;

dnb4a:=StrongNormalFormNP(AddNP(dnb4,MulNP(d2,MulNP(d2,MulNP(d12,d12))),1,h),G1);;
ynb4a:=StrongNormalFormNP(AddNP(ynb4,MulNP(y2,MulNP(y2,MulNP(y12,y12))),1,h),G1);;

ynb4g:=MulNP(ynb4a,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4a,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#In order to write the difference r112 more friendly, we define a new term called l

l1:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,MulNP(a1,a2))))),G1);;
l2:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a1,a2))))),G1);;
l3:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,a1))))),G1);;
l4:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,a1))))),G1);;

l:=AddNP(l1,AddNP(l2,AddNP(l3,l4,(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2*q21^2,(-4*E(12)^4-8*E(12)^7+4*E(12)^8-8*E(12)^11)*t1^2*q21),(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2,1),(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21,1);;

#We calculate the difference
Print("\n The difference between r112 and l is \n");
PrintNP(AddNP(r112,l,1,-1));

# The difference is zero. Then, we can rewrite the difference r112 using the term l

#Finally we write the term l on the PBW basis.

j:=(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21;;
f:=MulNP(a12,a12);;                                                                                                                                                      
ff:=MulNP(a2,MulNP(a2,f));;

PrintNP(StrongNormalFormNP(AddNP(l,ff,1,-j),G1));



#########################################################
Print("\n \n Case lambda1 nonzero, lambda2 zero, q21=E(3)\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^1*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y212,a212,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*E(3)^2*q21*t1^2;;

dnb4a:=StrongNormalFormNP(AddNP(dnb4,MulNP(d2,MulNP(d2,MulNP(d12,d12))),1,h),G1);;
ynb4a:=StrongNormalFormNP(AddNP(ynb4,MulNP(y2,MulNP(y2,MulNP(y12,y12))),1,h),G1);;

ynb4g:=MulNP(ynb4a,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4a,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#In order to write the difference r112 more friendly, we define a new term called l

l1:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,MulNP(a1,a2))))),G1);;
l2:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a1,a2))))),G1);;
l3:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,a1))))),G1);;
l4:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,a1))))),G1);;

l:=AddNP(l1,AddNP(l2,AddNP(l3,l4,(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2*q21^2,(-4*E(12)^4-8*E(12)^7+4*E(12)^8-8*E(12)^11)*t1^2*q21),(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2,1),(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21,1);;

#We calculate the difference
Print("\n The difference between r112 and l is \n");
PrintNP(AddNP(r112,l,1,-1));

# The difference is zero. Then, we can rewrite the difference r112 using the term l

#Finally we write the term l on the PBW basis.

j:=(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21;;
f:=MulNP(a12,a12);;                                                                                                                                                      
ff:=MulNP(a2,MulNP(a2,f));;

PrintNP(StrongNormalFormNP(AddNP(l,ff,1,-j),G1));



#########################################################
Print("\n \n Case lambda1 nonzero, lambda2 zero, q21=E(3)^2\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^2*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y212,a212,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*E(3)^2*q21*t1^2;;

dnb4a:=StrongNormalFormNP(AddNP(dnb4,MulNP(d2,MulNP(d2,MulNP(d12,d12))),1,h),G1);;
ynb4a:=StrongNormalFormNP(AddNP(ynb4,MulNP(y2,MulNP(y2,MulNP(y12,y12))),1,h),G1);;

ynb4g:=MulNP(ynb4a,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4a,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#In order to write the difference r112 more friendly, we define a new term called l

l1:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,MulNP(a1,a2))))),G1);;
l2:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a1,a2))))),G1);;
l3:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,MulNP(a2,a1))))),G1);;
l4:=StrongNormalFormNP(MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a2,MulNP(a1,a1))))),G1);;

l:=AddNP(l1,AddNP(l2,AddNP(l3,l4,(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2*q21^2,(-4*E(12)^4-8*E(12)^7+4*E(12)^8-8*E(12)^11)*t1^2*q21),(-8*E(12)^4-4*E(12)^7-8*E(12)^11)*t1^2,1),(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21,1);;

#We calculate the difference
Print("\n The difference between r112 and l is \n");
PrintNP(AddNP(r112,l,1,-1));

# The difference is zero. Then, we can rewrite the difference r112 using the term l

#Finally we write the term l on the PBW basis.

j:=(-8*E(12)^4-4*E(12)^8-8*E(12)^11)*t1^2*q21;;
f:=MulNP(a12,a12);;                                                                                                                                                      
ff:=MulNP(a2,MulNP(a2,f));;

PrintNP(StrongNormalFormNP(AddNP(l,ff,1,-j),G1));


#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=1\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^0*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);


#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^1*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^2\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^2*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^3\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^3*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^4\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^4*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^5\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^5*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^6\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^6*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^7\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^7*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^8\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^8*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^9\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^9*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^10\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^10*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^11\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^11*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

g13:=[[[2,2,2]],[F1]];;
g212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
a13:=[[[4,4,4]],[F1]];;
a212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y212:=[[[5,5,5,5,5,5,5,5,5,5,5,5]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a212d:=AddNP(AddNP(a212,[[[]],[F1]],1,-t2),g212,F1,t2);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y212d,a212d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;

g114:=StrongNormalFormNP(MulNP(g1,MulNP(g1,MulNP(g13,g13))),G1);;
g24:=StrongNormalFormNP(MulNP(g2,MulNP(g2,MulNP(g2,g2))),G1);;
gnb4:=StrongNormalFormNP(MulNP(g114,g24),G1);;

ynb4g:=MulNP(ynb4,gnb4);;

s112:=AddNP(anb4,ynb4g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);


